% 1. Unconditional replacement
:- multifile macro/2.


:- op(402,yfx,(=>)).
:- op(402,yfx,(<=)).

macro(A <= B,inverse(B => A)).

macro(Upper0 => Lower0, pragma([Upper-Upper0,Lower-Lower0],
      [[ ~ $ (Upper-[]), Upper x Lower ]*, ~ $ (Upper-[])])). 

macro(optional_replace(A0,B),pragma([A-A0], A => {B,A})).

macro(insert_brackets,[] <= {<, >}).

macro(remove_brackets,{<,>} => []).

macro(constrain_brackets, ~ $ [<,>]).

macro(dots_left(Left), [? *,ignore(Left,{<,>})]  - [? *,<] ).

macro(right_dots(Right), [ignore(Right,{<,>}),? *] - [>, ? *]    ).

macro(left_context(Left0), pragma([Left-Left0],
       ~[~dots_left(Left),  ignore(<,>),? *] &
       ~[ dots_left(Left),~[ignore(<,>),? *]]
	 )).

macro(right_context(Right0), pragma([Right-Right0],
       ~[  ? *,ignore(>,<), ~right_dots(Right)]   &
       ~[~[? *,ignore(>,<)], right_dots(Right)]
	 )).

macro(replace_b(Upper,Lower), 
       [<,ignore(Upper,{<,>}),>]  
                  =>
       [<,ignore(Lower,{<,>}),>]
	 ).

macro(replace_upward(Upper,Lower,Left,Right),  
        insert_brackets
              o
        constrain_brackets
              o
        left_context(Left)
              o
        right_context(Right)
              o
        replace_b(Upper,Lower)
              o
        remove_brackets
     ).
      
% this typically leads to `spurious' transducers, i.e. redundant
% transducers with p0 -[]/a-> p1 -a/[]->p
%                  p0 -a/[]-> p2 -[]/a->p
% 
