/* This file is generated automatically by FSA Utilities.
 * (c) 1993 - 2000 Gertjan van Noord RUG
 * More information from http://www.let.rug.nl/~vannoord/Fsa/
 * 
 * The representation of the finite-automaton is
 * similar to the technique explained on page 43 (table
 * 4.2) of Jan Daciuk's dissertation `Incremental
 * Construction of Finite-State Automata and Transducers
 * and their use in the Natural Language Processing'.
 * Politechnika Gdanska, 1998, except that instead of the number
 * of transitions we have a boolean flag indicating for each
 * line whether that line is the last transition for the current
 * state.
 */



import FSA.*;
public class c {
    private static final TransitionW tA [] = {
        /* sink                                        */
        new TransitionW(       0,   true,  false,      0,0,0),
        /* start state                                 */
        new TransitionW(       0,  false,   true,      2,0,0),
        /* normal transitions                          */
        new TransitionW(      97,  false,  false,      4,2,0),
        new TransitionW(      98,   true,  false,      5,4,0),
        new TransitionW(      97,   true,   true,      2,0,0),
        new TransitionW(      98,   true,   true,      6,0,0),
        new TransitionW(      98,   true,  false,      5,4,0),
    };

    public Integer weighs(String in)
    {
	return DFA.weighs(tA,in,0);
    }

    public void weighs_all ()
    {
	DFA.weighs_all(tA,0);
    }

 

        public static void main(String argv[]) {
	(new c()).weighs_all();
    }
}

