:- module(terms, [ term_hash/4,
                   term_hash/2 ]).

term_hash(A,B,C,D) :-
    (	B =:= -1
    ->	(   ground(A)
	->  hash_term(A,Key),
	    D is Key mod C
	;   raise_exception(fsa_error,"term_hash not ground: ~w~n",[A])
	)
    ;   raise_exception(fsa_error,
          "term_hash: second arg must be -1 (~w)~n",[B])
    ).

term_hash(A,D) :-
    term_hash(A,-1,16'1000000,D).

