.TH FSA 1
.SH NAME
fsa - various utilities to create finite automata from regular
expressions, to manipulate finite automata, and to visualise finite
automata. 
.SH SYNOPSIS

.B fsa [Options] 

.B yfsa [Options]

.B afsa [Options]

.SH DESCRIPTION
The \fIfsa\fP program can be used to manipulate finite state automata,
finite state transducers, and regular expressions. 

More info is available via http://www.let.rug.nl/~vannoord/Fsa/

.SH COPYRIGHT
Copyright \(co 1995-2000 by Gertjan van Noord. This program is distributed
under Gnu General Public License (cf. the file COPYING in
distribution).

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

.SH AUTHOR
Gertjan van Noord, vannoord@let.rug.nl. 

.SH MORE INFORMATION

Up-to-date information on the program can be obtained via the FSA
homepage located at 
.B http://www.let.rug.nl/~vannoord/Fsa/

There you will find:
.TP
*
Sources of the Latest version of FSA
.TP
*
FSA Reference Manual
.TP
*
Lots of example material to be used with FSA
.TP
*
Links to FSA tutorials

