:- module(charsio, [ format_to_chars/3,
		     format_to_chars/4,
		     read_from_chars/2
		   ]).

format_to_chars(Format,Args,Chars) :-
    sformat(String,Format,Args),
    string_to_list(String,Chars).
format_to_chars(Format,Args,Chars,Chars0) :-
    sformat(String,Format,Args),
    string_to_list(String,Chars1),
    lists:append(Chars1,Chars0,Chars).

read_from_chars(Chars,Term) :-
    atom_chars(Atom,Chars),
    atom_to_term(Atom,Term,_).
